
#pragma lib "libxml.a"

typedef struct Xml Xml;
typedef struct Attr Attr;
typedef struct Elem Elem;

typedef struct xml_tree xml_tree;
typedef struct xml_block xml_block;

#pragma incomplete xml_tree
#pragma incomplete xml_block

enum {
	Fcrushwhite = 1,
	Fstripnamespace = 2,
};

struct Xml {
	Elem *root;			/* root of tree */
	char *doctype;		/* DOCTYPE structured comment, or nil */
	struct {
		xml_tree *root;
		xml_block *active;
		int blksiz;
	} alloc;
};

struct Elem {
	Elem *next;			/* next element at this hierarchy level */
	Elem *child;		/* first child of this node */
	Elem *parent;		/* parent of this node */
	Attr *attrs;		/* linked list of atributes */
	char *name;			/* element name */
	char *pcdata;		/* pcdata following this element */
	int line;			/* Line number (for errors) */
};

struct Attr {
	Attr *next;			/* next atribute */
	Elem *parent;		/* parent element */
	char *name;			/* atributes name (NULL for coments) */
	char *value;		/* atributes value */
};

extern int xml_debug;

/* xml_attr.c */
Attr *xml_attr(Xml *xp, Attr **root, Elem *parent, char *name, char *value);

/* xml_elem.c */
Elem *xml_elem(Xml *xp, Elem **root, Elem *parent, char *name);

/* xml_find.c */
Elem *xml_find(Xml *xp, Elem *ep, char *path);

/* xml_look.c */
Elem *xml_look(Elem *ep, char *path, char *attr, char *value);

/* xml_malloc.c */
char *xml_strdup(Xml *xp, char *str, int iscommon);
void *xml_calloc(Xml *xp, long n, long m);
void xml_free(Xml *xp);

/* xml_new.c */
Xml *xml_new(int blksize);

/* xml_parse.c */
Xml *xml_parse(int fd, int blksize, int flags);
Xml *xml_Bparse(Biobuf *bp, int blksize, int flags);

/* xml_print.c */
void xml_print(Xml *xp, int header, int fd);
void xml_Bprint(Xml *xp, int header, Biobuf *bp);

/* xml_value.c */
char *xml_value(Elem *ep, char *name);
